summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--debian/tests/control2
-rwxr-xr-xtests/tests/gdr-diverge-nmu48
2 files changed, 49 insertions, 1 deletions
diff --git a/debian/tests/control b/debian/tests/control
index b324377..9cfd823 100644
--- a/debian/tests/control
+++ b/debian/tests/control
@@ -16,7 +16,7 @@ Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin
Restrictions: x-dgit-intree-only x-dgit-git-only
-Tests: gdr-edits gdr-import-dgit gdr-viagit
+Tests: gdr-diverge-nmu gdr-edits gdr-import-dgit gdr-viagit
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, git-buildpackage, libfile-fnmatch-perl, faketime
diff --git a/tests/tests/gdr-diverge-nmu b/tests/tests/gdr-diverge-nmu
new file mode 100755
index 0000000..2020d8f
--- /dev/null
+++ b/tests/tests/gdr-diverge-nmu
@@ -0,0 +1,48 @@
+#!/bin/bash
+set -e
+. tests/lib
+
+t-dependencies git-buildpackage libfile-fnmatch-perl faketime
+
+t-setup-import gdr-convert-gbp
+
+cd $p
+
+t-dgit setup-mergechangelogs
+
+: 'non-dgit upload (but we prepare it with dgit anyway)'
+
+v=2.0-2+nmu1
+t-nmu-upload-1 nmu
+gbp pq import
+t-nmu-upload-2
+echo >>newsrc.c "// more upstream"
+git add newsrc.c
+git commit -m 'UPSTREAM NMU'
+t-nmu-upload-3
+
+: 'done the nmu, switching back to the maintainer hat'
+
+t-dch-commit -v2.0-3 -m 'start -3'
+
+t-some-changes 'maintainer'
+t-git-debrebase
+t-git-debrebase stitch
+
+t-dgit fetch
+t-git-next-date
+
+t-expect-fail E:'Not.*fast-forward' \
+git merge --ff-only dgit/dgit/sid
+
+: 'ad hocery'
+
+git cherry-pick 'dgit/dgit/sid^{/UPSTREAM NMU}'
+
+t-expect-fail 'Automatic merge failed; fix conflicts' \
+git merge --squash -m 'Incorporate NMU' dgit/dgit/sid
+
+git rm -rf debian/patches
+git commit -m 'Incorporate NMU'
+
+t-ok